//-------------------------------------------------------------
// mmcSpecificConstsAndInterfaces.cs
//
// Contains constants and interfaces that are unique to this snapin
//-------------------------------------------------------------
using System;


namespace Microsoft.SampleMMC
{
    public class ThisSnapin
    {
        public const String     sBaseDir = "C:\\Program Files\\NGWSSDK\\Samples\\MMC\\html\\";
        public const String     sHelpFile = "C:\\Program Files\\NGWSSDK\\Samples\\MMC\\help\\snapsamp.chm";
    }// class ThisSnapin

    public interface IPropSheetPage
    {
        String Title();
        int    Icon();
        void Init(ref Object o);
        int InsertPropSheetPageControls(int hWnd);
        int ApplyData(); 
    }// IPropSheet

    public interface IColumnResultView
    {
        int getNumColumns();
        int getNumRows();
        String getColumnTitles(int iIndex);
        String getValues(int iX, int iY);
        void AddImages(ref IImageList il);
        int GetImageIndex(int i);

    }// IColumnResultView
        

    public struct NodeInfo
    {
        public String              sGuid;
        public String              sName;
        public String              sHelpLink;
        public Object              oResults;
        public String              sIcon;
        public IPropSheetPage[]    ppaPages;
        public int[]               iaChildren;
    }// struct NodeInfo

}// namespace Microsoft.SampleMMC
